# -*- coding:utf-8 -*-
import os
import sys
import time
import json
from baseClient import BaseClient
import numpy as np

class C22293Manager(BaseClient):
    def __init__(self):
        BaseClient.__init__(self)  # python 继承方式  
        self.device_name = "Chroma22293"     

    def setPattern(self, pattern, device=''):
        self.device_id = 1
        self.device_cmd = 'run ptn %s;\r' % pattern
        result = self.sendmsg()
        return result

    def setTiming(self, timing, device=''):
        self.device_id = 1
        self.device_cmd = 'run tim %s;\r' % timing
        result = self.sendmsg()
        return result

    def setTimingPattern(self, timing, pattern, device=''):
        self.device_id = 1
        self.device_cmd = 'run tim %s;run ptn %s;\r' % timing, pattern
        result = self.sendmsg()
        return result

    def getDeviceName(self, device=''):
        self.device_id = 1
        self.device_cmd = 'report model;\r'
        result = self.sendmsg()
        return result

    def getDeviceSoft(self, device=''):
        self.device_id = 1
        self.device_cmd = 'report ver;\r'
        result = self.sendmsg()
        return result

    def getStatus(self, device=''):
        self.device_id = 1
        self.device_cmd = 'dummy;\r'
        result = self.sendmsg()
        return result

    def setBlueOFF(self, device=''):
        self.device_id = 1
        self.device_cmd = 'b off;\r'
        result = self.sendmsg()
        return result

    def setBlueON(self, device=''):
        self.device_id = 1
        self.device_cmd = 'b on;\r'
        result = self.sendmsg()
        return result

    def setGreenOFF(self, device=''):
        self.device_id = 1
        self.device_cmd = 'g off;\r'
        result = self.sendmsg()
        return result

    def setGreenON(self, device=''):
        self.device_id = 1
        self.device_cmd = 'g on;\r'
        result = self.sendmsg()
        return result

    def setRedOFF(self, device=''):
        self.device_id = 1
        self.device_cmd = 'r off;\r'
        result = self.sendmsg()
        return result

    def setRedON(self, device=''):
        self.device_id = 1
        self.device_cmd = 'r on;\r'
        result = self.sendmsg()
        return result

    def setKeyBoardLock(self, device=''):
        self.device_id = 1
        self.device_cmd = 'kb lock on;\r'
        result = self.sendmsg()
        return result

    def setKeyBoardUnLock(self, device=''):
        self.device_id = 1
        self.device_cmd = 'kb lock off;\r'
        result = self.sendmsg()
        return result

if __name__ == "__main__":
    c2 = C22293Manager()
    print c2.getDeviceName()
    # ProHead = np.dtype({'names': ['version', 'len'], 'formats': ['B', 'i']})
    # a = np.array([(0xAA, 80)], dtype=ProHead)
    # print a, a.__len__(), a.itemsize
